![](https://bitbucket.org/batterio/regulome_web/raw/master/regulome_app/webapp/static/images/regulome_logo.jpg)

This repository contains the code of the Islet Regulome Browser.
The Islet Regulome Browser is a visualization tool that enables viewing 
of human islet TF bindings, human islet open chromatin states, clusters 
of enhancers, islet motifs, and DIAGRAM type2 diabetes association 
p-values as well as MAGIC fasting glycemia p-values at desired levels of 
resolution throughout the genome. In addition to these standard tracks, 
it is also possible for users to upload their own variants or regions 
sets for temporary display.


## Islet regulome dependencies  
* [Python 3.5](https://www.python.org/) and newer with the following packages:
    * Flask  
    * Click  
    * pandoc (optional)
    * Optional modules that will probably be used in the future are:  
        * intervaltree
        * SQLAlchemy
	    * Flask-SQLAlchemy
        * matplotlib
* [R](https://www.r-project.org/)
* [ImageMagick](http://www.imagemagick.org/)
    

## Islet regulome data sources  
Since the data sources are large files (~ 8Gb) contact the author (info@isletregulome.com) to download them.  


## How to install the regulome
The regulome browser can be installed with various approaches:  

  
### Through PyPI (recommended)  
    pip install regulome_web  
    

### Through the source package  
    pip install regulome_web-2.0.tar.gz  
Put, if necessary, the correct version of the program in the name of the package  
    
    
### By cloning the repository:  
* Clone the regulome repository:  
    `git clone git@bitbucket.org:batterio/regulome_web.git`  
* Install the package:  
    `pip install -e .`  
        *or*  
    `python setup.py`  
      
      
## How to run the regulome_web 
First, install the regulome_web as described above. Then write `regulome_web --help`
to obtain some basic information about the usage of the regulome_web.
Once the package is installed, create the required structure by executing
`regulome_web init`. This command will create a structure of folders as
well as a `regulome.cfg` configuration file. Configure the configuration
file and then run the regulome_web by executing `regulome_web start`.
This will start a local web server on `http://127.0.0.1:5000/`. To deploy the
regulome_web with a web service such as Apache, use the `regulome.wsgi`
file instead. In order to be used in production the regulome_web should 
be configured with a secure `secret_key` (to be set in the `regulome.cfg` 
configuration file) and the `deploy_mode` section of the `regulome.cfg` file
should be set to `production`.


## Description of the `regulome.cfg` configuration file
The `regulome.cfg` configuration file is composed of 7 fields, denoted by square brackets:  

* **binaries**: contains two variables:
	* **Rscript_bin**: path of the R binary
	* **imagemagick**: path of the imagemagick convert tool

* **working_directory**: contains one variable:
	* **cwd**: current working directory. This field is set automatically by the program when `regulome_web init` is executed

* **data**: contains two variables:
	* **data**: path of the data used by the R script to generate the plot. By default the program searches for the folder `data` in the current working directory (see above)
	* **uploads**: path where the files uploaded by the users are stored. By default the program searches for the folder `data/uploads` in the current working directory (see above)

* **output**: contains one variable:
	* **cache**: path where the results of the program (plots and tables) will be saved. By default the program searches for the folder `output` in the current working directory (see above). The default folder will be created, if not existing, when `regulome_web init` is executed

* **logs**: contains 4 variables:
	* **log_folder**: path where the logs of the program are written. By default the program searches for the folder `logs` in the current woring directory (seea bove). The default folder will be created, if not existing, when `regulome_web init` is executed
	* **activity_log**: path of the `activity.log` file. By default this file is placed inside `log_folder`
	* **regulome_log**: path of the `regulome.log` file. By default this file is placed inside `log_folder`
	* **log_level**: level of log verbosity: can be: notset, debug, info, warning, error, critical. By default log_level is set to info

* **deploy_mode**: contains one variable:
	* **configuration**: mode of deploy of the `regulome_web` program. Can be development, testing, production. By default cofiguration is set to development

* **secret_key**: contains one variable:
	* **key**: key used to encrypt the session coockies. Make sure to keep the key secret.

[![Stories in Ready](https://badge.waffle.io/brython-dev/brython.svg?label=ready&title=Ready)](http://waffle.io/brython-dev/brython)
[![Travis](https://api.travis-ci.org/brython-dev/brython.svg)](https://travis-ci.org/brython-dev/brython)


brython
=======

Brython (Browser Python) is an implementation of Python 3 running in the 
browser, with an interface to the DOM elements and events.

Here is a simple example of an HTML page running Python:

```xml
    <html>

        <head>
            <script type="text/javascript" src="/path/to/brython.js"></script>
        </head>

        <body onload="brython()">

            <script type="text/python">
            from browser import document, alert

            def echo(event):
                alert(document["zone"].value)

            document['mybutton'].bind('click', echo)
            </script>

            <input id="zone"><button id="mybutton">click !</button>

        </body>

    </html>
```

To use Brython, all there is to do is:

1. Load the script [brython.js](http://brython.info/src/brython.js "Brython from the site brython.info").
2. Run the function `brython()` on page load, like `<body onload=brython()>`.
3. Write Python code inside tags `<script type="text/python">` or linking it.


Main features
=============
Brython supports most of the syntax of [Python 3](https://www.python.org "Python Homepage"),
including comprehensions, generators, metaclasses, imports, etc.
and many modules of the CPython distribution.

It includes libraries to interact with DOM elements and events,
and with existing Javascript libraries such as jQuery, 3D, Highcharts, Raphael etc.
It supports lastest specs of HTML5/CSS3, and can use CSS Frameworks like Bootstrap3, LESS, SASS etc.


Getting started
===============
Zero install !
--------------
The most simple way to get started, without anything to install, is to use the 
distribution available online through [rawgit](https://rawgit.com/). You can 
either choose the latest stable release, for instance for release 3.2.2 :

```xml
<script type="text/javascript"
    src="https://cdn.rawgit.com/brython-dev/brython/3.2.2/www/src/brython.js">
</script>
```

or the current development version :

```xml
<script type="text/javascript" 
    src="https://cdn.rawgit.com/brython-dev/brython/master/www/src/brython.js">
</script>
```

The previous code will allow you to use raw python code but imports will fail as they are implemented using ajax calls and it will not work using http://rawgit.com/. If you want to test your projects using a standalone javascript file with the [available stdlib](https://github.com/brython-dev/brython/tree/master/www/src/Lib) included (so import would work) you should use:

```xml
<script type="text/javascript"
    src="https://cdn.rawgit.com/brython-dev/brython/3.2.2/www/src/brython_dist.js">
</script>
```

or the current development version :

```xml
<script type="text/javascript" 
    src="https://cdn.rawgit.com/brython-dev/brython/master/www/src/brython_dist.js">
</script>
```

Local install
-------------
You can also install the development environment locally, either by cloning the
project :

```bash
git clone https://github.com/brython-dev/brython.git
cd brython
python server.py
```

or by loading the latest version of the Brython site mirror from the 
[releases page](https://github.com/brython-dev/brython/releases).

In both cases, start the built-in web server : `python server.py`. This will 
point your browser to [http://localhost:8000/site](http://localhost:8000/site):
you access a clone of the [Brython site](http://brython.info "Brython Homepage")
with an online editor, a console similar to the CPython interpreter,
a gallery with many examples and a comprehensive documentation.

Once you are familiar with the examples, create a new folder "app" at the same
level as "site" and create a file "index.html" with the HTML example above.
Point the browser to [http://localhost:8000/app](http://localhost:8000/app) to 
see the result.

Test Brython online
===================
If you want to test Brython online you can visit the following:

- [Editor](http://brython.info/tests/editor.html "Online Brython Editor")
- [Console](http://brython.info/tests/console.html "Online Brython Console")


Gallery of examples
===================
There is a [gallery of examples](http://brython.info/gallery/gallery_en.html "gallery of examples")
where you can see simple and advanced examples using vanilla Brython or
interacting with other javascript libraries.


Documentation
=============
Documentation is available on the [official site](http://www.brython.info "Brython Homepage").
You can read the docs in [English](http://brython.info/doc/en/index.html),
[French](http://brython.info/doc/fr/index.html) and
[Spanish](http://brython.info/doc/es/index.html).

The most updated docs usually are the English and French versions so if you 
want to be up-to-date, please, use these versions.

Curious about [how Brython works](https://github.com/brython-dev/brython/wiki/How%20Brython%20works) ?

Community (questions, feedback, issues, new features, ...)
==========================================================
There is a main [mailing list in English](https://groups.google.com/forum/?fromgroups=#!forum/brython "Brython Main Mailing List").
Also, you can find [mail list in other languages](http://brython.info/groups.html "Brython Mailing Lists")
but the activity is very low and it is recommended to use the main one in English.

If you find a bug/issue or do you want to see a new feature in Brython, please,
[open a new issue](https://github.com/brython-dev/brython/issues "Brython GitHub Issues").

There's a [Brython Community on Google Plus](https://plus.google.com/communities/114694456237115550531).

IRC: #brython on [freenode](https://webchat.freenode.net/)

Agile Development
=================

- [**Brython KanBan of Tickets**](https://waffle.io/brython-dev/brython "Agile Development Kanban") *Whats Brython Team working on ?*

- **Throughput Graph:** *Statistics about our work...*

[![Throughput Graph](https://graphs.waffle.io/brython-dev/brython/throughput.svg)](https://waffle.io/brython-dev/brython/metrics)


Thank you
=========

- [BrowserStack](http://www.browserstack.com) for providing an access
to their online testing environment.

#######################################
## plot_IRB_00LoadAndCreateObjects.R ##
#######################################
##-----------------------------------------------------------------------------------------------
## This script needs to be called by plot_IRB_main.R in order to load and generate the
## new data objects using given arguments to draw the plot.
##-----------------------------------------------------------------------------------------------

##-----------------------------------------------------------------------------------------------
## Fixing start and stop coordinates
##-----------------------------------------------------------------------------------------------
start <- start - ranges
stop <- stop + ranges
ws <- input_window

##-----------------------------------------------------------------------------------------------
## Fixing path of the files
##-----------------------------------------------------------------------------------------------
tfs <- paste(base_name, separator, paste0(tfs, mapTF, ".rda"), sep=build)
regRegions <- paste(base_name, separator, paste0(regRegions, mapRegion, ".rda"), sep=build)
chromatin <- paste(base_name, separator, paste0(chromatin, mapChrom, ".bedgraph.gz"), sep=build)
lncRNA <- paste(base_name, separator, lncRNA, sep=build)
ideogram <- paste(base_name, separator, ideogram, sep=build)
if (mapRegion == "adult") {
  cluster <- paste(base_name, separator, clusterG3, sep=build)
  load(file=cluster)
} else if (mapRegion == "adultStretch") {
  cluster <- paste(base_name, separator, clusterS, sep=build)
  load(file=cluster)
} else {
  cluster <- c()
}
genes <- paste(base_name, separator, genes, sep=build)

##-----------------------------------------------------------------------------------------------
## Read in data: hard coded
##-----------------------------------------------------------------------------------------------
load(file=regRegions)
load(file=lncRNA)
load(file=specific_genes)
load(file=tfs)
load(file=ideogram)
load(file=paste0(genes, chromosome, '.rda')) 
# Read the diagram file
if (plot_diagram == TRUE) {
  diagram <- paste(base_name, separator, diagram, sep=build)
  if (chromosome != "chrX" & chromosome != "chrY") {
    load(file=paste0(diagram, chromosome, '.rda'))
  } else {
    load(file=paste0(diagram, 'chr0.rda'))
  }
}

# Read the magic file
if (plot_magic == TRUE) {
  magic <-  paste(base_name, separator, magic, sep=build)
  if (chromosome != "chrX" & chromosome != "chrY") {
    load(file=paste0(magic, chromosome, '.rda'))
  } else {
    load(file=paste0(magic, 'chr0.rda'))
  }
}
# The motifs data will be loaded eventually if the plot is <= 1000bp

##-----------------------------------------------------------------------------------------------
## Generate variables of interest
##-----------------------------------------------------------------------------------------------
# Vector of the TF analyzed (automatically length of TFs in dataset)
head <- names(tfs)[4:ncol(tfs)]

# Locus
if (!chromosome %in% unique(tfs$chr)) {message(paste("Cannot find chromosome", chromosome, "in the file", sep=" ")); q()}
if (!start) {start <- min(tfs[tfs$chr == chromosome,])}
if (!stop) {stop <- max(tfs[tfs$chr == chromosome,])}

# Chromosome length
if (build == "hg18") {
  chromosome.length <- chromosome_lengths_hg18[which(chromosome_names == chromosome)]
} else if (build == "hg19") {
  chromosome.length <- chromosome_lengths_hg19[which(chromosome_names == chromosome)]
} else if (build == "hg38") {
  chromosome.length <- chromosome_lengths_hg38[which(chromosome_names == chromosome)]
} else {
  message("The human build (-B) should be hg18, hg19, or hg38"); q()
}

# Limit the start between 0 <= start <= chromosome.length - 100
if (start < 0) {start = 0}
if (start > chromosome.length) {start = chromosome.length - 100}

# Limit the stop between 100 <= stop <= chromosome.length
if (stop < 100) {stop = 100}
if (stop > chromosome.length) {stop = chromosome.length}

# TFs comprised in the region of interest
locus <- tfs[tfs$chr == chromosome & tfs$Start >= start & tfs$End <= stop, ]
d = (stop - start) / 20

locus2 <- tfs[tfs$chr == chromosome, ]
locus2 <- locus2[(locus2$Start >= start & locus2$Start <= stop) | 
                   (locus2$End >= start & locus2$End <= stop) |
                   (locus2$Start <= start & locus2$End >= stop), ]

# These are the coordinates where the TFs will be drawn
intervals <- seq(start, stop, (stop - start) / (length(head) * 2))
intervals <- intervals[seq(2, length(intervals), 2)]

# Regulatory regions comprised in the region of interest
regions <- regRegions[regRegions[, 1] == chromosome,]
regions <- regions[(regions[, 2] >= start & regions[, 2] <= stop) | 
                     (regions[, 3] >= start & regions[, 3] <= stop) | 
                     (regions[, 2] <= start & regions[, 3] >= stop), ]

# Cluster C3 
if (mapRegion == "adult" | mapRegion == "adultStretch") {
  cluster <- cluster[cluster[, 1] == chromosome, ]
  cluster <- cluster[(cluster[, 2] >= start & cluster[, 2] <= stop) |
                       (cluster[, 3] >= start & cluster[, 3] <= stop) |
                       (cluster[, 2] <= start & cluster[, 3] >= stop), ]
}


# Strength of the binding: how many TFs bind per regions
locus$Binding <- rowSums(locus[, 4:ncol(locus)])
locus2$Binding <- rowSums(locus2[, 4:ncol(locus2)])

# Variables
output_plot <- paste0("plots/IRB_", gsub(" ", "_", Sys.time()), ".pdf")
output_file <- paste0("plots/IRB_", gsub(" ", "_", Sys.time()), ".txt")
output_snp <- paste0("plots/IRB_", gsub(" ", "_", Sys.time()), ".snp.txt")
output_motifs <- ""
input_window <- 100
format_plot <- "pdf"

# PDX1
start = 28494167
stop = 28500451
chromosome = "chr13"

build <- "hg19"
ranges <- 50000
mapTF <- 'adult'
mapRegion <- 'adult'
mapChrom <- "beta"  # 'HI08_1'
input_user_regions <- "input_reg_test.bed"
input_user_snps <- "input_snp.txt"
plot_diagram <- FALSE
plot_magic <- TRUE

############################
## plot_IRB_06PlotGenes.R ##
############################
##-----------------------------------------------------------------------------------------------
## This script draws the bottom plot in plot_IRB_main.R, which contains the ideograms for genes, 
## and a color scale of grey representing specificity of the gene to the adult islet.
##-----------------------------------------------------------------------------------------------

##-----------------------------------------------------------------------------------------------
## Open plot
##-----------------------------------------------------------------------------------------------
par(mar=c(0, 0, 0, 0))
plot(1, xlim=c(start - d, stop + d), ylim=c(0, 10), col='white', ylab="", yaxt='n', xaxt='n', xlab="", type='n')

##-----------------------------------------------------------------------------------------------
## Plot genes
##-----------------------------------------------------------------------------------------------
# Select and order the genes
genes.all <- genes[(genes$Start >= start & genes$Start <= stop) |
                 (genes$Stop >= start & genes$Stop <= stop) | 
                 (genes$Start <= start & genes$Stop >= stop), ]

genes.all <- genes.all[order(genes.all$Start), ]
genes <- genes.all
g.genes <- genes[genes$Type=="GENE",]
g.genes <- g.genes[!duplicated(g.genes$Gene),]
genes <- rbind(g.genes, genes[genes$Type=="EXON",])

len_reg <- stop - start

# Min. space required to plot the strand of a gene
w <- len_reg / 50

occupancy <- matrix(-1, ncol=3, nrow=sum(genes$Type == "GENE"))
gene_count <- 0

if (nrow(genes) >= 1) {
  for (gene_name in unique(genes$Gene)) {
    for (numgene in 1:nrow(genes[genes$Gene == gene_name & genes$Type == "GENE", ])) {
      gene <- genes[genes$Gene == gene_name & genes$Type == "GENE", ][numgene, ]
      gene_count <- gene_count + 1
      
      # Characteristics of the gene
      gene_id <- gene[, 7]
      gene_strand <- gene[, 2]
      gene_start <- gene[, 3]
      gene_stop <- gene[, 4]
      gene_middle <- mean(c(gene_start, gene_stop))
      gene_overlap <- 1 #gene[, 7]
      
      # Gene length
      gene_length <- gene_stop - gene_start
      
      # Color of the gene
      if (gene_id %in% spec_genes) {
        specificity <- GENE_SPEC
      } else {
        specificity <- GENE_UNSPEC
      }
      
      # Strand
      y <- c(8.5, 8, 7.5)
      if (gene_strand == "+") {
        x <- c(gene_start, gene_start + w / 2, gene_start)
      } else {
        x <- c(gene_stop, gene_stop - w / 2, gene_stop)
      }
      
      border <- specificity #'NA'
      
      # Draw the gene - First draws a line representing the introns
      lines(c(gene_start, gene_stop), rep(y[2], 2), col=border)
      
      # Draw the strand if the gene is big enough
      if (gene_length >= w / 2) {
        j <- floor(gene_length/(w)) - 1
        for (k in 0:j) {
          if (k < 0) next
          col <- border
          if (gene_strand == "+") {
            nx <- as.numeric(x) + w * k
          } else {
            nx <- as.numeric(x) - w * k
          }
          lines(nx, y, col=col)
        }
      }
      
      # Write the name of the gene 
      occ <- nchar(as.character(gene_id)) * w
      
      start_text <- as.integer(gene_middle - occ / 2)
      stop_text <- as.integer(gene_middle + occ / 2)
      
      # Check if the name of the gene will overlap with an already written gene's name
      traffic <- sum(start_text >= occupancy[, 1] & start_text <= occupancy[, 2]) + 
        sum(stop_text >= occupancy[, 1] & stop_text <= occupancy[, 2]) + 
        sum(start_text < occupancy[, 1] & stop_text > occupancy[, 2])
      
      if (traffic >= 2) {
        y <- 0
      } else {
        if (traffic == 1) {
          if (occupancy[(gene_count - 1), 3] == 4) {y <- 1} else {y <- 4}
        } else {
          y <- 4
        }
      }
      
      if (y > 0) {
        # Write the gene's name on the plot
        text(gene_middle, y, labels=c(as.character(gene_id)), cex=1.5, font=3)
        
        # Draw a dashed line from the gene to the text
        lines(rep(gene_middle, 2), c(y + 1, 7), lty=2, col="grey40")
      }
      
      # Update occupancy
      occupancy[gene_count, ] <- c(start_text, stop_text, y)
      
      # Now draw the exons
      cds <- genes[genes$Gene == gene_name & genes$Type == "EXON", ]
      rect(cds[, 3], rep(7, nrow(cds)), cds[, 4], rep(9, nrow(cds)), col=specificity, border=border)
    }
  }
}

##-----------------------------------------------------------------------------------------------
## lncRNA
##-----------------------------------------------------------------------------------------------
# Select and order the lncRNA
lncRNA <- lncRNA[(lncRNA[, 1] == chromosome & lncRNA[, 2] >= start & lncRNA[, 2] <= stop) |
                   (lncRNA[, 1] == chromosome & lncRNA[, 3] >= start & lncRNA[, 3] <= stop) | 
                   (lncRNA[, 1] == chromosome & lncRNA[, 2] <= start & lncRNA[, 3] >= stop), ]

lncRNA <- lncRNA[order(lncRNA[, 2]), ]

occupancy_tmp <- matrix(-1, ncol=3, nrow=nrow(lncRNA))
occupancy <- rbind(occupancy, occupancy_tmp)

# Pointer of the genes data in the occupancy matrix
mark <- sum(genes$Type == "GENE")

if (nrow(lncRNA) >= 1) {
  for (i in 1:nrow(lncRNA)) {
    line <- lncRNA[i, ]
    lncRNA_name <- as.character(as.matrix(line[4])) #paste("hincRNA", unlist(strsplit(as.matrix(line[4]), "_"))[2], sep="")
    lncRNA_start <- as.numeric(line[2])
    lncRNA_stop <- as.numeric(line[3])
    lncRNA_middle <- mean(c(lncRNA_start, lncRNA_stop))
    lncRNA_length <- lncRNA_stop - lncRNA_start
    strand <- line[5] 
    
    y <- c(8.5, 8, 7.5)
    if (strand == "+") {
      x <- c(lncRNA_start, lncRNA_start + w / 2, lncRNA_start)
    } else {
      x <- c(lncRNA_stop, lncRNA_stop - w / 2, lncRNA_stop)
    }
    
    # Draw the lncRNA
    rect(lncRNA_start, 7.5, lncRNA_stop, 8.5, col='black', border='black')
    
    # Draw the strand if the gene is big enough
    if (lncRNA_length >= w/2) {
      j <- as.integer(floor(lncRNA_length/w)) - 1
      for (k in 0:j) {
        if (strand == "+") {
          nx <- as.numeric(x) + w * k
        } else {
          nx <- as.numeric(x) - w * k
        }
        lines(nx, y, col='white')
      }
    }
    
    # Write the name of the gene 
    occ <- nchar(lncRNA_name) * w
    
    start_text <- as.integer(lncRNA_middle - occ / 2)
    stop_text <- as.integer(lncRNA_middle + occ / 2)
    
    # Check if the name of the lncRNA will overlap with an already written lncRNA's name
    traffic <- sum(start_text >= occupancy[, 1] & start_text <= occupancy[, 2]) + 
      sum(stop_text >= occupancy[, 1] & stop_text <= occupancy[, 2]) + 
      sum(start_text < occupancy[, 1] & stop_text > occupancy[, 2])
    if (traffic >= 2) {
      y <- 0
    } else {
      if (traffic == 1) {
        if (occupancy[(mark + i - 1), 3] == 4) {y <- 1} else {y <- 4}
      } else {
        y <- 4
      }
    }
    
    if (y > 0) {
      # Write the lncRNA's name on the plot
      text(lncRNA_middle, y, labels=c(lncRNA_name), cex=1.5)
      
      # Draw a dashed line from the gene to the text
      lines(rep(lncRNA_middle, 2), c(y + 1, 7.5), lty=2, col="grey40")
    }
    
    # Update occupancy
    occupancy[(mark + i),] <- c(start_text, stop_text, y)	
  }
}

# Axis
a <- axis(1, cex.axis=2, label=F)
rng <- a[length(a)] - a[1]

# Format the axis
if (rng / 1000000 >= 1) {
  div <- 1000000
  b <- "Mb"
} else if (rng / 1000000 < 1 & rng / 1000 >= 1) {
  div <- 1000
  b <- "Kb"
} else {
  div <- 1
  b <- "bp"
}
mtext(side=1, at=a, text=a/div, line=1.5, cex=1.3)
mtext(side=1, paste0("Position ", "(", b, ")"), line=4, cex=1.5)

# Borders of the main figure
abline(v=par('usr')[1:2])
abline(h=par('usr')[3])

# Close the image
dev.off()

##########################################################
# Authors	: Loris Mularoni and Mireia Ramos            #
##########################################################
# This script draws the main plot for the Islet Regulome #
# Browser, using SNPs, motifs, enhancers and TFs data    #
# contained in data/ folder. Needs to be called with     #
# another program and the variables to create the plot   #
# are provided as command line arguments.                #
##########################################################


##########################################################
## Load the config file
##--------------------------------------------------------
initial_dir <- getwd()

getScriptPath <- function(){
  cmd.args <- commandArgs()
  m <- regexpr("(?<=^--file=).+", cmd.args, perl=TRUE)
  script.dir <- dirname(regmatches(cmd.args, m))
  if (length(script.dir) == 0) stop("can't determine script dir: please call the script with Rscript")
  if (length(script.dir) > 1) stop("can't determine script dir: more than one '--file' argument detected")
  return(script.dir)
}
.dir <- getScriptPath()
setwd(.dir)
source("plot_IRB_config.R")


##########################################################
## Sets default values for variables
##--------------------------------------------------------
output_plot <- ""
output_file <- ""
output_snp <- ""
output_motifs <- ""
output_rna <- ""
input_window <- 10
format_plot <- "pdf"
start <- FALSE
stop <- FALSE
build <- FALSE
chromosome <- FALSE
ranges <- 0
mapTF <- 'adult'
mapRegion <- 'adult'
mapChrom <- FALSE
input_user_regions <- FALSE
input_user_snps <- FALSE
plot_diagram <- TRUE
plot_magic <- FALSE


##########################################################
## Read command line arguments
##--------------------------------------------------------
readCommandLineArgs <- function() {
  args <- commandArgs(TRUE)
  # Set usage message if less than 4 arguments are provided.
  if (length(args) < 4) {
    message(paste(term.cyan, "\nThis program creates a plot with the density of TF binding site.\n", sep=""))
    message(paste(term.yellow, "Usage:\n", term.green, "\tplot_IRB_main.R
                  -p,  output_plot
                  -o,  output_file
                  -s,  output_snp
                  -M,  output_motifs
                  -R,  output_rna
                  -f,  format_plot
                  -B,  build
                  -c,  chromosome
                  -b,  start
                  -e,  stop
                  -r,  ranges
                  -Mt, mapTF
                  -Mr, mapRegion
                  -Mc, mapChromatin
                  -d,  plot_diagram
                  -m,  plot_magic
                  -u,  input_user_regions
                  -U,  input_user_snps
                  -w,  input_window" , sep="")) #-i,  input_file
    
    message(paste(term.yellow, "where:", sep=""))
    message(paste(term.green, "\toutput_plot          : name of the plot to save with results."), sep="")
    message("\toutput_file          : name of the text file to save with the results.")
    message("\toutput_snp           : name of the text file to save with the snp results.")
    message("\toutput_motifs        : name of the text file to save with the motif results.")
    message("\toutput_rna           : name of the text file to save with the RNA expression results.")
    message("\tformat_plot          : format of the plot (pdf, bitmap, or jpeg). Default is pdf.")
    message("\tbuild                : human build used (hg18, hg19, or hg38).")
    message("\tchromosome           : specify which chromosome to analize.")
    message("\tstart                : define in which point of the chromosome the plot will start.")
    message("\tstop                 : define in which point of the chromosome the plot will end.")
    message("\tranges               : extend the plot around start and stop.")
    message("\tmapTF                : select map of transcription factors to use. Available: 'progenitor' and 'adult' (default).")
    message("\tmapRegion            : select map of regions to plot. Available: 'progenitor', 'adultStretch' and 'adult' (default).")
    message("\tmapChromatin         : select map of chromatin regions to plot. Available: 'alpha', 'beta' (optional).")
    message("\tplot_diagram         : plot the DIAGRAM dataset of snps (TRUE or FALSE). Default is TRUE.")
    message("\tplot_magic           : plot the MAGIC dataset of snps (TRUE or FALSE). Default is FALSE.")
    message("\tinput_user_regions   : file with regions to represent in the plot. The file should have 3 colums.")
    message("\tinput_user_snps      : file with snps to represent in the plot. The file should have at least 3 colums.")
    message("\t                       The maximum number of SNP datasets that can be plotted is two, so this option")
    message("\t                       will be ignored if the DIAGRAM and MAGIC datasets will be used.")
    message("\tinput_window         : window to calculate the density. Not functional yet.")
    message(paste("\t                       Default is 100.\n", term.normal, sep=""))
    q()
  }
  
  # Assigning values from command line arguments to variables.
  i <- 1
  while (i < length(args)) {
    opt <- args[i]
    val <- args[i + 1]
    if (opt == "-p") { output_plot <<- val }
    if (opt == "-o") { output_file <<- val }
    if (opt == "-s") { output_snp <<- val }
    if (opt == "-M") { output_motifs <<- val }
    if (opt == "-R") { output_rna <<- val }
    if (opt == "-w") { input_window <<- as.numeric(val) }
    if (opt == "-f") { format_plot <<- val }
    if (opt == "-B") { build <<- val }
    if (opt == "-c") { chromosome <<- as.character(val) }
    if (opt == "-b") { start <<- as.numeric(val) }
    if (opt == "-e") { stop <<- as.numeric(val) }
    if (opt == "-r") { ranges <<- as.numeric(val)}
    if (opt == "-Mt") { mapTF <<- as.character(val)}
    if (opt == "-Mr") { mapRegion <<- as.character(val)}
    if (opt == "-Mc") { mapChrom <<- as.character(val)}
    if (opt == "-d") { plot_diagram <<- val}
    if (opt == "-m") { plot_magic <<- val}
    if (opt == "-u") { input_user_regions <<- val}
    if (opt == "-U") { input_user_snps <<- val}
    if (opt != "-o" & opt != "-s" & opt != "-w" & opt != "-p" & opt != "-f" & opt != "-b" &
        opt != "-e" & opt != '-B' & opt != '-c' & opt != '-r' & opt != "-u" & opt != "-U" &
        opt != "-Mt" & opt != "-Mr" & opt!="-Mc" & opt != "-d" & opt != "-m" & opt != "-M" & opt != "-R") {
            message(paste("Argument", opt, "is not a valid option", sep = " "))
            q()
        }
    i <- i + 2
  }
  
  # Setting error messages if need variables are empty/incorrect
  if (output_plot == "") {
      message("One or some of the arguments are missing"); q()
  }
  if (format_plot != "bitmap" & format_plot != "pdf" & format_plot != 'jpeg') {
      message("The format of the plot is not valid"); q()
  }
  if (build == FALSE) {
      message("You have to specify the human build to use in the analysis (hg18, hg19, or hg38)")
      q()
  }
  if (build != "hg18" & build != "hg19" & build != "hg38") {
      message("The human build (-B) should be hg18, hg19, or hg38"); q()
  }
  if (mapTF != "adult" & mapTF != "progenitor") {
      message("The chosen map (-Mt) should be 'adult' or 'progenitor'"); q()
  }
  if (mapRegion != "adult" & mapRegion != "progenitor" & mapRegion != "adultStretch") {
      message("The chosen map (-Mr) should be 'adult', 'adultStretch' or 'progenitor'"); q()
  }
  if (mapChrom != FALSE & mapChrom != "alpha" & mapChrom != "beta") {
      message("The chosen map (-Mc) should be 'alpha' or 'beta'"); q()
  }
  if (chromosome == FALSE) {
      message("You have to specify a chromosome to plot"); q()
  }
  if (plot_diagram != FALSE & plot_diagram != TRUE) {
      message("plot_diagram (-d) should be TRUE or FALSE"); q()
  }
  if (plot_magic != FALSE & plot_magic != TRUE) {
      message("plot_magic (-m) should be TRUE or FALSE"); q()
  }
  if (plot_diagram == TRUE & plot_magic == TRUE) {
      input_user_snps <<- FALSE
  }
}

readCommandLineArgs()
# source("plot_IRB_testVariables.R")  # variables for testing plot


##########################################################
## Load and create needed data objects
##--------------------------------------------------------
source("plot_IRB_00LoadAndCreateObjects.R")


##########################################################
## DRAWING MAIN PLOT
##########################################################
##--------------------------------------------------------
## Open the image
##--------------------------------------------------------
if (format_plot == "bitmap") {
	bitmap(file=output_plot, width=10, height=8, res=300, pointsize=12)
} else {
	if (format_plot == "pdf") {
		#postscript(file=output_plot, onefile=FALSE, horizontal=FALSE, width=10, height=8, paper="special")
		pdf(file=output_plot, onefile=FALSE, width=10, height=8, paper="special", bg="white")
	} else {
		jpeg(file=output_plot, width=600, height=480, res=300, pointsize=12)
	}
}


##--------------------------------------------------------
## Define layout of the plot
##--------------------------------------------------------
layout(matrix(1:7, 7, 1), heights=c(2, 1.5, 8, 0.8, 5, 2, 1))


##--------------------------------------------------------
## Create legend
##--------------------------------------------------------
source("plot_IRB_01Legend.R")


##--------------------------------------------------------
## Create header of plot (chr ideogram and genomic info)
##--------------------------------------------------------
source("plot_IRB_02IdeogramHeader.R")


##--------------------------------------------------------
## Top plot (SNPs and MOTIFS (<=1000bp))
##--------------------------------------------------------
source("plot_IRB_03SNPmotifOpenChrom.R")


##--------------------------------------------------------
## Middle plot (regions)
##--------------------------------------------------------
source("plot_IRB_04PlotRegions.R")


##--------------------------------------------------------
## Bottom plot (TF and binding lines)
##--------------------------------------------------------
source("plot_IRB_05PlotTFBS.R")


##--------------------------------------------------------
## Draw genes (darker grey = more specific to HI)
##--------------------------------------------------------
source("plot_IRB_06PlotGenes.R")


##--------------------------------------------------------
## Output files
##--------------------------------------------------------
if (output_file != "") {
  if (mapRegion == "adult") {
    # Order the regions and delete column 5
    cluster[, 4] <- rep("C3 cluster", nrow(cluster))
    regions <- rbind(regions, cluster)
    regions <- regions[order(regions[, 2], -regions[, 3]), -c(5)]
    colnames(regions) <- c("CHR", "START", "END", "CHROMATIN_CLASS", "TF")
    regions$Build <- rep(build, nrow(regions))
    
    if (nrow(regions) > 0) {
      # Write to the output file
      write.table(file=output_file, regions, quote=F, row.names=F, col.names=T, sep="\t")
    }
  } else if (mapRegion == "adultStretch") {
    cluster[, 4] <- rep("Stretch Enhancer", nrow(cluster))
    regions <- rbind(regions, cluster)
    regions <- regions[order(regions[, 2], -regions[, 3]),]
    colnames(regions) <- c("CHR", "START", "END", "CHROMATIN_STATE")
    regions$Build <- rep(build, nrow(regions))
    
    if (nrow(regions) > 0) {
      # Write to the output file
      write.table(file=output_file, regions, quote=F, row.names=F, col.names=T, sep="\t")
    }
  } else if (mapRegion == "progenitor") {
    regions <- regions[order(regions[, 2], -regions[, 3]), -c(5)]
    colnames(regions) <- c("CHR", "START", "END", "REGULATORY_ELEMENT", "TF")
    regions$Build <- rep(build, nrow(regions))
    
    if (nrow(regions) > 0) {
      # Write to the output file
      write.table(file=output_file, regions, quote=F, row.names=F, col.names=T, sep="\t")
    }
  }
}

if (output_snp != "") {
	written <- FALSE
	# Write to the output file
	if (nrow(subdiagram) > 0) {
        subdiagram <- subdiagram[order(subdiagram$PVAL),]
		subdiagram$DATASET <- rep("diagram", nrow(subdiagram))
		subdiagram$BUILD <- rep(build, nrow(subdiagram))
		write.table(file=output_snp, subdiagram, quote=F, row.names=F,
				col.names=ifelse(!written, TRUE, FALSE), sep="\t",
				append=written)
		written <- TRUE
	}
	if (nrow(submagic) > 0) {
        submagic <- submagic[order(submagic$PVAL),]
		submagic$DATASET <- rep("magic", nrow(submagic))
		submagic$BUILD <- rep(build, nrow(submagic))
		write.table(file=output_snp, submagic, quote=F, row.names=F,
				col.names=ifelse(!written, TRUE, FALSE), sep="\t",
				append=written)
		written <- TRUE
	}
	if (nrow(sub_user_snp) > 0) {
        sub_user_snp <- sub_user_snp[order(sub_user_snp$PVAL),]
		if (ncol(sub_user_snp) < 4) {sub_user_snp <- cbind(rep("-", nrow(sub_user_snp)), sub_user_snp)}
		sub_user_snp$DATASET <- rep("user", nrow(sub_user_snp))
		sub_user_snp$BUILD <- rep(build, nrow(sub_user_snp))
		write.table(file=output_snp, sub_user_snp, quote=F, row.names=F,
				col.names=ifelse(!written, TRUE, FALSE), sep="\t",
				append=written)
		written <- TRUE
	}
}

if (output_motifs != "") {
	if (nrow(motifs) > 0) {
		motifs$Build <- rep(build, nrow(motifs))
		write.table(file=output_motifs, cbind(seq(1, nrow(motifs)), motifs), quote=F, row.names=F, col.names=T, sep="\t")
    }
}

if (output_rna != "") {
  if (nrow(genes.all) > 0) {
    genes.all$Build <- rep(build, nrow(genes.all))
    genes.all <- genes.all[genes.all$Type == "GENE", c(1:4, 6:9)]
    colnames(genes.all) <- c("CHR", "STRAND", "START", "END", "UCSC_ID", "SYMBOL", "EXPRESSION", "BUILD")
    write.table(file=output_rna, genes.all, quote=F, row.names=F, col.names=T, sep="\t")
  }
}

#################
# ENF OF SCRIPT #
#################

####################################
## plot_IRB_03SNPmotifOpenChrom.R ##
####################################
##-----------------------------------------------------------------------------------------------
## This script draws the top plot in plot_IRB_main.R, which contains: SNPs (magic and/or diagram),
## motifs (if region <1kb) and open chromatin densities.
##-----------------------------------------------------------------------------------------------

#################################################################################################
## FUNCTIONS TO BE CALLED LATER
##-----------------------------------------------------------------------------------------------
PlotSideLegend <- function(range.p, max.pos, size.pos, real_y, user=FALSE) {
##-----------------------------------------------------------------------------------------------
  
  PlotBlock <- function(x, y) {
    points(x.pos.r2, range.p - x, pch=22, cex=4, bg=y, col=y)
  }
  
  WriteText <- function(step, label) {
    text(x.pos.r2, range.p - step, labels=label, pos=1)
  }
  
  step.y <- range.p / 25
  step.ry <- real_y / 25
  x.pos.r2 <- max.pos - (size.pos * 0.005)
  
  range.steps <- step.y * 11:1
  if (user == FALSE) {hsvs <- snp_colors} else {hsvs <- user_snp_colors}
  mapply(PlotBlock, range.steps, hsvs)
  
  text.steps <- step.y * c(0, 5, 10.3, 12)
  # Put real_y to rescale
  labels <- c(as.character(round(y, 1)), as.character(round(y / 2, 1)), "0", "pvalue\n-log10")
  mapply(WriteText, text.steps, labels)
}

##-----------------------------------------------------------------------------------------------
PlotSnp <- function(y, x, real_y, user=FALSE) {
##-----------------------------------------------------------------------------------------------
  # use y instead of real_y to get the same scale in all the datasets
  range.steps <- seq(0, y, y / 10)
  range.steps[11] <- y
  if (user == FALSE) {hsvs <- snp_colors} else {hsvs <- user_snp_colors}
  i <- as.numeric(cut(-log10(x$PVAL), range.steps))
  points(x$POS, -log10(x$PVAL), pch=21, cex=1, bg=hsvs[i], col=hsvs[ifelse(i > 5, i, 5)], lwd=0.5)
}

##-----------------------------------------------------------------------------------------------
parseSnps <- function(snps, y_snps, y, start, stop, d, label="", user=FALSE) {
##-----------------------------------------------------------------------------------------------
  if (nrow(snps) > 0) {
    # Snps
    tmp <- PlotSnp(y, snps, y_snps, user=user)
    
    # Side legend
    if (user==TRUE) {
      tmp <- PlotSideLegend(y, start - d, (stop - start + d + d), y_snps, user=TRUE)
      axis(2, cex.axis=1.5) 
      mtext(side=2, text=label, cex=1.5, line=3)
    } else {
      tmp <- PlotSideLegend(y, stop + d, (stop - start + d + d), y_snps, user=FALSE)
      axis(4, cex.axis=1.5)
      mtext(side=4, text=label, cex=1.5, line=3) #,col=snp_colors[length(snp_colors)]
    }
    
    # Best snp. check if the column SNP exists
    if ("SNP" %in% colnames(snps)) { #ncol(snps) > 3) 
      best.snp <- snps[order(snps$PVAL), ][1, ]
      if (best.snp$POS <= (start + stop) / 2) { pos = 4 } else { pos = 2 }
      text(best.snp$POS, -log10(best.snp$PVAL), labels=as.character(best.snp$SNP), pos=pos, cex=1.2)
    }
  }
}

##-----------------------------------------------------------------------------------------------
plot_motifs <- function(motifs, start, stop, p="lines") {
##-----------------------------------------------------------------------------------------------
  let <- strsplit(as.character(motifs[, 5]), "")     # Nucleotides of the motifs
  ll <- unlist(lapply(let, length))   # Length of the motifs
  cb <- cbind(motifs[, 2], ll)         # Position and length of the motifs
  ncb <- c()
  for (n in 1:nrow(cb)) { ncb <- c(ncb, seq(cb[n, 1], (cb[n, 1] - 1 + cb[n, 2]))) }
  max_overlap <- max(table(ncb)) * 2  # Temp
  # Matrix of bases x max_overlap
  matmot <- matrix(0, nrow=(stop - start) + 10, ncol=max_overlap)
  index = 1
  motifs_count = 1
  
  for (n in 1:nrow(cb)) {
    # Coordinates in bp
    X = seq(cb[n, 1], (cb[n, 1] - 1 + cb[n, 2]))
    
    # Coordinates of the matmot
    Xcords <- X - min(ncb) + 1
    
    # Decide which index to use
    for (i in max_overlap:1) {
      if (max(matmot[Xcords, i]) == 0) { index <- i }
    }
    
    # Look if the previous base is occuped
    if (min(Xcords) > 1) {
      if (matmot[min(Xcords) - 1, index] == 1) { index <- index + 1 }
    }
    
    # Update matrix
    matmot[(X - min(ncb) + 1), index] <- 1
    
    # Write the motif
    if (p == "lines") {
      lines(x=c(min(X), max(X)), y=rep(ytext[index], 2), lwd=2)
    } else {
      text(x=X, y=ytext[index], labels=unlist(let[[n]]), cex=1)
    }
    
    # Add an index
    text(x=mean(X), y=ytext[index], labels=motifs_count, cex=0.7, pos=3)
    
    # Add a point upsteam the motifs
    motifs_count <- motifs_count + 1  
  }
}

#################################################################################################
## CODE FOR DRAWING THE PLOT
##-----------------------------------------------------------------------------------------------
## Draw SNPs
##-----------------------------------------------------------------------------------------------
par(mar=c(0, 0, 0, 0))

y_user <- 1
y_diagram <- 1
y_magic <- 1
subdiagram <- matrix(numeric(0), 0, 0)
submagic <- matrix(numeric(0), 0, 0)
sub_user_snp <- matrix(numeric(0), 0, 0)

# User data
if (input_user_snps != FALSE) {
  # Look if the "rda" file exist, otherwise read a text file and save the "rda" file
#  if (file.exists(paste(input_user_snps, ".rda", sep=""))) {
#    load(paste(input_user_snps, ".rda", sep=""))
#  } else {
    user_snp <- read.delim(input_user_snps, sep="\t", header=T, stringsAsFactors=F)
#    colnames(user_snp) <- c("CHR", "POS", "PVAL", "NAME")
#    save(file=paste(input_user_snps, ".rda", sep=""), user_snp)
#  }
  
  sub_user_snp <- user_snp[user_snp$CHR == chromosome & user_snp$POS >= start & user_snp$POS <= stop, ]
  if (nrow(sub_user_snp) > 0) { y_user <- max(-log10(sub_user_snp$PVAL)) }
}

# Diagram data
if (plot_diagram == TRUE) {
  subdiagram <- diagram[diagram$CHR == chromosome & diagram$POS >= start & diagram$POS <= stop, ]
  if (nrow(subdiagram) > 0) { y_diagram <- max(-log10(subdiagram$PVAL)) }
}

# Magic data
if (plot_magic == TRUE) {
  submagic <- magic[magic$CHR == chromosome & magic$POS >= start & magic$POS <= stop, ]
  if (nrow(submagic) > 0) { y_magic <- max(-log10(submagic$PVAL)) }
}

# Absolute higher y-value
y <- ceiling(max(y_diagram, y_user, y_magic))

# Plot data
if (nrow(subdiagram) > 0 | nrow(submagic) > 0 | nrow(sub_user_snp) > 0) {
  # Open plot
  plot(1, xlim=c(start - d, stop + d), ylim=c(0, y), col='white', ylab="", yaxt='n', xlab="", xaxt='n', type='n')
  
  # Diagram
  if (nrow(subdiagram) > 0) {parseSnps(subdiagram, y_diagram, y, start, stop, d, label="Diagram", user=FALSE);}
  
  # Magic
  if (nrow(submagic) > 0) {
    if (nrow(subdiagram) > 0) { user=TRUE } else { user=FALSE }
    parseSnps(submagic, y_magic, y, start, stop, d, label="Magic", user=user)
  }
  
  # User
  if (nrow(sub_user_snp) > 0 & mapChrom == FALSE) {
    if (nrow(subdiagram) > 0 | nrow(submagic) > 0) { user=TRUE } else { user=FALSE }
    parseSnps(sub_user_snp, y_magic, y, start, stop, d, label="User dataset", user=user)
  } else {
    if (nrow(subdiagram) > 0 | nrow(submagic) > 0) { user=TRUE } else { user=FALSE }
    parseSnps(sub_user_snp, y_magic, y, start, stop, d, label="", user=user)
  }
  
} else {
  # Open plot
  plot(1, xlim=c(start - d, stop + d), ylim=c(0, 1), col='white', ylab="", yaxt='n', xlab="", xaxt='n', type='n')
}

##-----------------------------------------------------------------------------------------------
## Plot motifs if the plot <= 1kb long
##-----------------------------------------------------------------------------------------------
if ((stop - start) <= 1000) { 
  # Load the motifs file
  motifs <- paste(base_name, separator, motifs, sep=build)
  load(file=motifs)
  motifs <- motifs[motifs[, 1] == chromosome & motifs[, 2] >= start & motifs[, 2] <= stop, ]
  motifs <- motifs[order(motifs[, 2]), ] 
  # y measure for the motifs
  ytext <- seq(0, y, y / 10)
  yt2 = y / 23
  if (nrow(motifs) > 0) {
    # 100bp
    if (((stop - start) <= 100)) { plot_motifs(motifs=motifs, start=start, stop=stop, p="characters") }
    # 100bp - 1000bp
    if (((stop - start) <= 1000) & ((stop - start) > 100)) { 
      plot_motifs(motifs=motifs, start=start, stop=stop, p="lines") 
    }
  }
} else {
  output_motifs = ""
}

# Borders of the main figure
abline(v=par('usr')[1:2])

##-----------------------------------------------------------------------------------------------
## Open chromatin plot
##-----------------------------------------------------------------------------------------------
if (mapChrom != FALSE) {
  region <- GenomicRanges::GRanges(seqnames=chromosome,
                    ranges=IRanges::IRanges(start, stop)
                    )

  ## Only one bedgraph
  # Define colors for the plot (transparency does not work if you use color names directly)
  transparency = 0.8
  col1 = col2rgb("dark green")
  finalcolor1 = rgb(col1[1],col1[2],col1[3],alpha=transparency * 255, maxColorValue = 255)

  # Import tabix file
  tab <- Rsamtools::TabixFile(chromatin, paste0(chromatin, ".tbi"))
  regChromatin <- rtracklayer::import(tab, genome=build, which=region)
  df <- GenomicRanges::as.data.frame(regChromatin)[,c(1,2,3,6)]
  # df$score <- df$score*5/max(df$score)

  # Draw plot
  par(new=TRUE) # Draw in same plot, use new axis
  max <- round(max(df$score)+sd(df$score))
  plot(1, xlim=c(start - d, stop + d), ylim=c(0,max), col='white', ylab="", yaxt='n', xlab="", xaxt='n', type='n')
  Sushi::plotBedgraph(df, chromosome, start, stop, overlay=T, color=finalcolor1, reescaleoverlay=T, ylim=c(0, 20))

  if (mapChrom == "HI18" | mapChrom == "HI08_1") {
    lab <- c(0,20) #by=((max(df$score)+sd(df$score))/5)), 0)
    axis(2, lab, cex.axis=1.3, tick=T, las=1) #at=lab,
    title <- paste0("ATAC-seq human islet-3")
  } else {
    lab <- c(0, max) #by=((max(df$score)+sd(df$score))/5)), 0)
    axis(2, lab, cex.axis=1.3, tick=T, las=1) #at=lab,
    title <- paste0("Open chromatin/", mapChrom, " cell")
  }
  mtext(side=2, text=title, cex=1.3, line=3) #col=finalcolor1
}
#
#
#
# ## With two bedgraphs
# # col2 = col2rgb("#E5001B")
# # finalcolor2 = rgb(col2[1],col2[2],col2[3],alpha=transparency * 255,maxColorValue = 255)
# # color <- c(finalcolor2, finalcolor1)
# 
# # cont=1
# # transp <- c(0.5, 1)
# # for (chro in chromatin) {
# #   tab <- TabixFile(chro, paste0(chro, ".tbi"))
# #   regChromatin <- import(tab, genome=build, which=region)
# #   df <- as.data.frame(regChromatin)[,c(1,2,3,6)]
# #   plotBedgraph(df, chromosome, start, stop, overlay=T, color=color[cont], transparency=transp[cont], reescaleoverlay=T, alpha=0.5)
# #   cont=cont+1
# # }
# # axis(4, cex.axis=1.3) 
# # mtext(side=4, text="Open chrom", cex=1.4, line=3)
